Class | Needle::ServicePoint
In: | lib/needle/service-point.rb
Parent: | Object

A "service point" is a definition of a service. Just as a class defines the behavior of an object, so does a service point describe a service. In particular, a service point also knows how to instantiate a service.

A ServicePoint should never be directly instantiated. Instead, define services via the interfaces provided by Container.

### Methods

fullname instance interceptor new

### Attributes

container | [R] | A reference to the container that contains this service point.
name | [R] | The name of this service point, as it is known to the container that it was registered in.
pipeline | [R] | The reference to the instantiation pipeline used by this service point.

### Public Class methods

new( container, name, opts={}, &callback )

Create a new service point that references the given container and has the given name. The associated callback will be used to instantiate the service on demand.

The `:model` option is used to tell Needle which style of life-cycle management should be used for the service. It defaults to `:singleton`. The model must be a symbol that refers to a service model that has been registered in the root `:service_models` service.

The `:pipeline` option is mutually exclusive with `:model`. It must be an array of symbols (or strings) that define the instantiation pipeline to use for this service. Each element must correspond to an entry in the `:pipeline_elements` service.

### Public Instance methods

fullname()

Returns the fully-qualified name of the service point, with the point‘s name, its container‘s name, and all of its container‘s ancestors’ names concatenated together with dot characters, i.e. "one.two.three".

instance( actual_container, *args )

Return the service instance represented by this service point. Depending on the style of lifecycle management chosen for this service point, this may or may not be a new instance for every invocation of this method.

The first argument is the container that should be used to resolve this service point. Assuming the container to be used is this service point‘s own container would mean that any nested service points couldn‘t override service points their parents’ service points used.

Any extra arguments to this method will be passed through to the chain, which may cause an error if there is an element in the pipeline that does not accept additional arguments. Regardless, the first two parameters to the chain will always be the container and the service point.

interceptor( interceptor )

Adds the given interceptor definition to this service point. The parameter should act like an instance of Interceptor.

[Validate]